"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var content_1 = require("@steroidsjs/core/ui/content");
var hooks_1 = require("@steroidsjs/core/hooks");
var renderIcon_1 = __importDefault(require("../../utils/renderIcon"));
function MenuView(props) {
    var bem = (0, hooks_1.useBem)('MenuView');
    var MenuItemView = props.itemView;
    var renderMenuItems = react_1["default"].useCallback(function () { return (react_1["default"].createElement(react_1["default"].Fragment, null, props.items.map(function (item, index) { return (react_1["default"].createElement(MenuItemView, __assign({ key: index }, item))); }))); }, [MenuItemView, props.items]);
    return (react_1["default"].createElement(content_1.DropDown, __assign({}, props.dropDownProps, { className: bem(bem.block(), props.className), content: renderMenuItems }),
        react_1["default"].createElement("span", { className: bem.element('button') }, props.icon
            ? (0, renderIcon_1["default"])(props.icon, { className: bem.element('icon') })
            : (react_1["default"].createElement(content_1.Icon, { name: 'menu_dots', className: bem.element('icon') })))));
}
exports["default"] = MenuView;
