"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var isEmpty_1 = __importDefault(require("lodash-es/isEmpty"));
var Text_1 = __importDefault(require("@steroidsjs/core/ui/typography/Text/Text"));
var content_1 = require("@steroidsjs/core/ui/content");
require("./AutoCompleteFieldView.scss");
var normalizeItems = function (items) {
    var categories = {};
    var itemsWithoutCategory = [];
    items.forEach(function (item) {
        if (item.category) {
            if (categories[item.category]) {
                categories[item.category].push(item);
                return;
            }
            categories[item.category] = [item];
            return;
        }
        itemsWithoutCategory.push(item);
    });
    return {
        categories: categories,
        itemsWithoutCategory: itemsWithoutCategory
    };
};
var renderItem = function (item, props, bem) {
    var _a, _b, _c;
    var hasAdditionalIcon = !!((_a = item.additional) === null || _a === void 0 ? void 0 : _a.icon);
    var hasAdditionalText = !!((_b = item.additional) === null || _b === void 0 ? void 0 : _b.text);
    var hasSomeAdditional = hasAdditionalText || hasAdditionalIcon;
    var uniqId = item[props.primaryKey];
    return (React.createElement("button", { key: String(uniqId), className: bem.element('item', {
            hover: props.hoveredId === uniqId,
            select: props.selectedIds.includes(uniqId)
        }), onClick: function () { return props.onItemSelect(uniqId); }, onFocus: function () { return props.onItemHover(uniqId); }, onMouseOver: function () { return props.onItemHover(uniqId); } },
        React.createElement("span", { className: bem.element('item-label') }, item.label),
        hasSomeAdditional && (React.createElement("div", { className: bem.element('item-additional') },
            hasAdditionalIcon && (React.createElement(content_1.Icon, { name: (_c = item.additional) === null || _c === void 0 ? void 0 : _c.icon, className: bem.element('item-additional-icon') })),
            hasAdditionalText && (React.createElement("span", { className: bem.element('item-additional-text') }, item.additional.text))))));
};
function AutoCompleteFieldView(props) {
    var bem = (0, hooks_1.useBem)('AutoCompleteFieldView');
    var renderItems = React.useCallback(function () {
        if (!(0, isEmpty_1["default"])(props.categories)) {
            var _a = normalizeItems(props.items), categories = _a.categories, itemsWithoutCategory = _a.itemsWithoutCategory;
            return (React.createElement(React.Fragment, null,
                Object.entries(categories).map(function (_a) {
                    var category = _a[0], categoryItems = _a[1];
                    return (React.createElement("div", { key: category, className: bem.element('category') },
                        React.createElement("span", { className: bem.element('category__label') }, category),
                        React.createElement("div", { className: bem.element('category__content') }, categoryItems.map(function (item) { return renderItem(item, props, bem); }))));
                }),
                itemsWithoutCategory.map(function (item) { return renderItem(item, props, bem); })));
        }
        return (React.createElement(React.Fragment, null, props.items.map(function (item) { return renderItem(item, props, bem); })));
    }, [bem, props]);
    return (React.createElement("div", { ref: props.forwardedRef, className: bem(bem.block({
            size: props.size,
            opened: props.isOpened
        }), props.className), style: props.style },
        React.createElement("input", __assign({}, props.inputProps, { className: bem(bem.element('input'), props.inputProps.className), onClick: function (e) {
                e.preventDefault();
                props.onOpen();
            }, onChange: function (e) { return props.inputProps.onChange(e.target.value); }, placeholder: props.placeholder, disabled: props.disabled, required: props.required })),
        props.isOpened && (React.createElement("div", { className: bem.element('drop-down') },
            React.createElement("div", { className: bem.element('list') }, !(0, isEmpty_1["default"])(props.items)
                ? renderItems()
                : (React.createElement(Text_1["default"], { type: 'textSm', content: __('Nothing was found'), className: bem.element('nothing') })))))));
}
exports["default"] = AutoCompleteFieldView;
