"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var react_1 = require("react");
var hooks_1 = require("@steroidsjs/core/hooks");
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var utils_1 = require("./utils");
function DropDownFieldView(props) {
    var _a;
    var bem = (0, hooks_1.useBem)('DropDownFieldView');
    var inputRef = (0, react_1.useRef)(null);
    // Auto focus on search
    (0, react_1.useEffect)(function () {
        if (props.isSearchAutoFocus && props.isAutoComplete && props.isOpened && (inputRef === null || inputRef === void 0 ? void 0 : inputRef.current)) {
            inputRef.current.focus();
        }
    }, [props.isAutoComplete, props.isOpened, props.isSearchAutoFocus]);
    var renderPlaceholder = React.useCallback(function () {
        var _a;
        return props.placeholder && !((_a = props.selectedIds) === null || _a === void 0 ? void 0 : _a.length)
            ? (React.createElement("div", { className: bem.element('placeholder') }, props.placeholder))
            : null;
    }, [bem, props.placeholder, props.selectedIds]);
    return (React.createElement("div", { ref: props.forwardedRef, className: bem(bem.block((_a = {
                size: props.size
            },
            _a["".concat(props.color)] = !!props.color && !props.outline,
            _a["outline_".concat(props.color)] = props.outline,
            _a.opened = props.isOpened,
            _a)), props.className), onKeyPress: function (e) { return e.key === 'Enter' && props.onOpen(); }, style: props.style, role: "button", tabIndex: 0 },
        React.createElement("div", { className: bem.element('selected-items', {
                reset: props.showReset,
                disabled: props.disabled
            }), onClick: props.onOpen, tabIndex: -1, role: 'button' },
            renderPlaceholder(),
            React.createElement("span", { className: bem.element('selected-items') }, props.showEllipses
                ? (0, utils_1.getSelectedItemsLabel)(props.selectedItems)
                : (0, utils_1.getSelectedItemsCount)(props.selectedItems))),
        props.showReset && props.selectedIds.length > 0 && (React.createElement(Icon_1["default"], { name: "cross_8x8", className: bem.element('icon-close'), tabIndex: -1, onClick: props.onReset, "aria-label": __('Сбросить') })),
        React.createElement(Icon_1["default"], { name: 'arrow_down_24x24', className: bem.element('icon-chevron'), tabIndex: -1, onClick: props.onOpen }),
        props.isOpened && (React.createElement("div", { className: bem.element('drop-down') },
            props.isAutoComplete && (React.createElement("div", { className: bem.element('search', {
                    size: props.size
                }) },
                React.createElement(Icon_1["default"], { name: 'search', className: bem.element('search-icon') }),
                React.createElement("input", __assign({}, props.searchInputProps, { ref: inputRef, onChange: function (e) { return props.searchInputProps.onChange(e.target.value); }, className: bem(bem.element('search-input'), props.searchInputProps.className) })))),
            React.createElement("div", { className: bem.element('drop-down-list') }, props.items.map(function (item) { return props.renderItem(item); }))))));
}
exports["default"] = DropDownFieldView;
