"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var DropDownField_1 = require("@steroidsjs/core/ui/form/DropDownField/DropDownField");
var renderIcon_1 = __importDefault(require("../../utils/renderIcon"));
var AccordionItemView_1 = __importDefault(require("../../content/Accordion/AccordionItemView"));
var CheckboxFieldView_1 = __importDefault(require("../CheckboxField/CheckboxFieldView"));
var RadioFieldView_1 = __importDefault(require("../RadioField/RadioFieldView"));
function DropDownItemView(props) {
    var _a;
    var bem = (0, useBem_1["default"])('DropDownItemView');
    var commonProps = {
        className: bem.element('option', {
            hover: props.hoveredId === props.item[props.primaryKey],
            select: props.selectedIds.includes(props.item[props.primaryKey]),
            size: props.size
        }),
        onFocus: function () { return props.onItemHover(props.item[props.primaryKey]); },
        onMouseOver: function () { return props.onItemHover(props.item[props.primaryKey]); },
        onClick: function (e) {
            e.preventDefault();
            props.onItemSelect(props.item[props.primaryKey]);
        }
    };
    switch (props.type) {
        case DropDownField_1.GROUP_CONTENT_TYPE:
            return (react_1["default"].createElement(AccordionItemView_1["default"], { isShowMore: props.isShowMore, childIndex: props.childIndex, toggleCollapse: props.toggleCollapse, toggleAccordion: function () { }, showIcon: true, title: props.item.label, position: "middle", key: props.item[props.primaryKey], className: bem.element('group', {
                    size: props.size
                }) }, (_a = props.item[props.groupAttribute]) === null || _a === void 0 ? void 0 : _a.map(function (subItem, itemIndex) { return (react_1["default"].createElement(DropDownItemView, __assign({}, props, { type: subItem.type ? subItem.type : props.itemsContent.type, key: itemIndex, item: subItem }))); })));
        case DropDownField_1.ICON_CONTENT_TYPE:
            return (react_1["default"].createElement("div", __assign({}, commonProps, { key: props.item[props.primaryKey] }),
                (0, renderIcon_1["default"])(props.item.contentSrc, { className: bem.element('icon') }),
                react_1["default"].createElement("span", null, props.item.label)));
        case DropDownField_1.CHECKBOX_CONTENT_TYPE:
            return (react_1["default"].createElement("div", __assign({}, commonProps, { key: props.item[props.primaryKey] }),
                react_1["default"].createElement(CheckboxFieldView_1["default"], { label: props.item.label, className: bem.element('checkbox'), size: props.size, inputProps: {
                        disabled: false,
                        name: props.item.label,
                        checked: props.selectedIds.includes(props.item[props.primaryKey]),
                        onChange: function () { },
                        type: 'checkbox'
                    } })));
        case DropDownField_1.RADIO_CONTENT_TYPE:
            return (react_1["default"].createElement("div", __assign({}, commonProps, { key: props.item[props.primaryKey] }),
                react_1["default"].createElement(RadioFieldView_1["default"], { label: props.item.label, className: bem.element('radio', {
                        size: props.size
                    }), size: props.size, inputProps: {
                        disabled: false,
                        name: props.item.label,
                        checked: null,
                        onChange: function () { },
                        type: 'radio'
                    }, checked: props.selectedIds.includes(props.item[props.primaryKey]) })));
        case DropDownField_1.IMG_CONTENT_TYPE:
            return (react_1["default"].createElement("div", __assign({}, commonProps, { key: props.item[props.primaryKey] }),
                react_1["default"].createElement("span", { className: bem.element('img') },
                    react_1["default"].createElement("img", { src: props.item.contentSrc, alt: "custom source for item" })),
                react_1["default"].createElement("span", null, props.item.label)));
        default:
            return (react_1["default"].createElement("div", __assign({}, commonProps, { key: props.item[props.primaryKey] }), props.item.label));
    }
}
exports["default"] = DropDownItemView;
