"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
var renderIcon_1 = __importDefault(require("../../utils/renderIcon"));
function InputFieldView(props) {
    var bem = (0, hooks_1.useBem)('InputFieldView');
    return (React.createElement("div", { className: bem(bem.block({
            disabled: props.inputProps.disabled,
            size: props.size,
            hasError: !!props.errors,
            hasLeadIcon: !!props.leadIcon,
            hasClearIcon: props.showClear && !props.disabled,
            filled: !!props.inputProps.value,
            hasAddonAfter: !!props.addonAfter,
            hasAddonBefore: !!props.addonBefore,
            hasAddon: !!props.addonAfter || !!props.addonBefore,
            hasTextAddon: !!props.textAfter || !!props.textBefore,
            hasTextAddonBefore: !!props.textBefore,
            hasTextAddonAfter: !!props.textAfter
        }), props.className), style: props.style },
        props.addonBefore && (React.createElement("span", { className: bem.element('addon-before') }, props.addonBefore)),
        props.textBefore && (React.createElement("span", { className: bem.element('text-before') }, props.textBefore)),
        React.createElement("div", { className: bem.element('input-wrapper') },
            props.leadIcon && (0, renderIcon_1["default"])(props.leadIcon, {
                className: bem.element('lead-icon'),
                tabIndex: -1
            }),
            props.maskProps
                ? (React.createElement("input", { onBlur: props.onBlur, onFocus: props.onFocus, onMouseDown: props.onMouseDown, className: bem(bem.element('input', {
                        size: props.size
                    })), type: props.type, placeholder: props.placeholder, disabled: props.disabled, required: props.required, id: props.id }))
                : (React.createElement("input", __assign({ className: bem(bem.element('input', {
                        size: props.size
                    })) }, props.inputProps, { onChange: function (e) { return props.input.onChange(e.target.value); }, type: props.type, placeholder: props.placeholder, disabled: props.disabled, required: props.required, id: props.id }))),
            !props.disabled && props.showClear && !props.maskProps && (React.createElement(Icon_1["default"], { name: "cross_8x8", className: bem.element('icon-clear'), tabIndex: -1, onClick: props.onClear }))),
        props.textAfter && (React.createElement("span", { className: bem.element('text-after') }, props.textAfter)),
        props.addonAfter && (React.createElement("span", { className: bem.element('addon-after') }, props.addonAfter))));
}
exports["default"] = InputFieldView;
