"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var react_1 = require("react");
var isNumber_1 = __importDefault(require("lodash-es/isNumber"));
var hooks_1 = require("@steroidsjs/core/hooks");
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/content/Icon"));
function NumberFieldView(props) {
    var _a;
    // Input ref
    var inputRef = (0, react_1.useRef)(null);
    var onStepUp = (0, react_1.useCallback)(function () {
        inputRef.current.stepUp();
        props.inputProps.onChange(inputRef.current.value);
    }, [props.inputProps]);
    var onStepDown = (0, react_1.useCallback)(function () {
        inputRef.current.stepDown();
        props.inputProps.onChange(inputRef.current.value);
    }, [props.inputProps]);
    var bem = (0, hooks_1.useBem)('NumberFieldView');
    return (React.createElement("div", { className: bem(bem.block({
            disabled: props.inputProps.disabled,
            size: props.size,
            hasErrors: !!props.errors,
            filled: !!((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.value)
        }), props.className) },
        React.createElement("input", __assign({ ref: inputRef, className: bem(bem.element('input')) }, props.inputProps, { onChange: function (e) { return props.input.onChange(e.target.value); }, id: props.id })),
        !props.disabled && !props.errors && (React.createElement("div", { className: bem.element('arrows-container') },
            React.createElement("button", { className: bem.element('arrow', {
                    disabled: (0, isNumber_1["default"])(props.inputProps.max) && props.inputProps.value >= props.inputProps.max
                }), type: 'button', onClick: onStepUp },
                React.createElement(Icon_1["default"], { name: 'expand_up', tabIndex: -1 })),
            React.createElement("button", { className: bem.element('arrow', {
                    disabled: (0, isNumber_1["default"])(props.inputProps.min) && props.inputProps.value <= props.inputProps.min
                }), type: 'button', onClick: onStepDown },
                React.createElement(Icon_1["default"], { name: 'expand_up', tabIndex: -1 })))),
        React.createElement("span", { className: bem.element('input-effects') })));
}
exports["default"] = NumberFieldView;
